<div infiniteScroll [infiniteScrollDistance]="0.2" [infiniteScrollThrottle]="300" (scrolled)="onScroll()">
  <div class="home">
    <div class="left">
      <!-- STORIES -->
      <div class="story-title" *ngIf="(stories$ | async)?.length > 0">Recent Stories</div>
      <div class="stories">
        <div class="story" *ngFor="let story of stories$ | async">
          <div class="story-image" (click)="openStoryModal(story)">
            <img [src]="getImageUrl(story.story[0].content)" alt="" />
            <div class="story-thumbnail">
              <img [src]="getImageUrl(story.image)" alt="" />
            </div>
          </div>
        </div>
      </div>
      <!-- STORIES -->

      <div class="posts">
        <div class="post" *ngFor="let post of posts$ | async">
          <div class="user">
            <!-- Profile Pic -->
            <div
              class="post-thumbnail"
              (click)="post.user.has_stories.length > 0 ? openStoryModal(post.user) : ''"
              [ngClass]="withStory(post.user.has_stories.length > 0) ? 'with-story' : ''"
              (click)="navigateBasedOnStoriesAndUserId(post.user.has_stories, post.user_id)"
            >
              <img [src]="post.user.image ? getImageUrl(post.user.image) : 'assets/images/no-image.png'" />
            </div>
            <!-- Profile Pic -->

            <!-- Profile Name -->
            <div class="name" (click)="navigateBasedOnUserId(post.user_id)">
              {{ post.user.fname }} {{ post.user.lname }}
            </div>
            <!-- Profile Name -->
          </div>

          <div
            [ngClass]="{
              'first': myCarousel?.activeId == '0',
              'last': myCarousel?.activeId == post.contents.length - 1
            }"
          >
            <ngb-carousel
              #myCarousel
              [showNavigationArrows]="post.contents.length > 1"
              [showNavigationIndicators]="post.contents.length > 1"
              interval="0"
            >
              <ng-template ngbSlide *ngFor="let content of post.contents; let i = index" [id]="i">
                <div class="picsum-img-wrapper">
                  <img *ngIf="content.type !== 'video'" [src]="getImageUrl(content.content)" class="image" />
                  <div class="video-overlay" *ngIf="content.type === 'video'">
                    <video controls>
                      <source [src]="getImageUrl(content.content)" />
                    </video>
                  </div>
                </div>
              </ng-template>
            </ngb-carousel>
          </div>

          <div class="post-options">
            <div class="options">
              <i
                class="fa fa-star icon"
                [ngClass]="isLiked(post.is_liked) ? 'active' : ''"
                (click)="onLikePost(post)"
              ></i>

              <i class="fa fa-comment icon" [routerLink]="['/post', post.id]"></i>
              <button
                type="button"
                class="delete"
                *ngIf="userId === post.user_id"
                (click)="onDeletePost(post.caption, post.id)"
              >
                Delete
              </button>
            </div>
            <!-- <i class="fa fa-share icon"></i> -->
            <span class="date-ago">{{ post.created_at | dateAgo }}</span>
          </div>
          <div class="like-count" *ngIf="post.likes_count > 1 || post.likes_count === 0; else one_like">
            {{ post.likes_count }} Likes
          </div>
          <ng-template #one_like>
            <div class="like-count">{{ post.likes_count }} Like</div>
          </ng-template>
          <div
            class="caption"
            [innerHTML]="convertHashTags(post.caption ? post.caption : '')"
            (click)="goToHashTag($event)"
          >
            {{ post.caption }}
          </div>
          <!-- Comments -->
          <form #f="ngForm" (ngSubmit)="onAddComment(f, post.id)">
            <div class="comments">
              <div class="comment" *ngFor="let comment of post.comments | slice: -2; let i = index">
                <div
                  class="comment-thumbnail"
                  (click)="comment.user.has_stories.length > 0 ? openStoryModal(comment.user) : ''"
                  [ngClass]="withStory(comment.user.has_stories.length > 0) ? 'with-story' : ''"
                  (click)="navigateBasedOnStoriesAndUserId(comment.user.has_stories, comment.user_id)"
                >
                  <img
                    [src]="comment.user.image ? getImageUrl(comment.user.image) : 'assets/images/no-image.png'"
                    alt=""
                  />
                </div>

                <div class="comment-body">
                  <div (click)="navigateBasedOnUserId(comment.user_id)">
                    <div class="comment-name">{{ comment.user.fname }} {{ comment.user.lname }}</div>
                  </div>
                  <div
                    class="comment-content"
                    [innerHTML]="convertHashTags(comment.comment)"
                    (click)="goToHashTag($event)"
                  >
                    {{ comment.comment }}
                  </div>

                  <div class="comment-options">
                    <button
                      type="button"
                      class="icon"
                      (click)="onLikeComment(comment)"
                      [ngClass]="isLiked(comment.is_liked) ? 'active' : ''"
                    >
                      {{ comment.likes_count }}
                      <i class="fa fa-star"></i>
                    </button>
                    <button
                      type="button"
                      class="delete"
                      *ngIf="userId === comment.user.id"
                      (click)="onDeleteComment(post.id, comment)"
                    >
                      Delete
                    </button>
                  </div>

                  <br />
                </div>
                <div class="comment-date">{{ comment.created_at | dateAgo }}</div>
              </div>
              <span class="view-all-comments" *ngIf="post.comments.length > 2" [routerLink]="['/post', post.id]">
                View all {{ post.comments.length }} comments
              </span>
              <div class="comment-box" *ngIf="profile$ | async as profile">
                <div
                  class="comment-thumbnail"
                  [ngClass]="withStory(profile.has_stories.length > 0) ? 'with-story' : ''"
                  (click)="profile.has_stories.length > 0 ? openStoryModal(profile) : ''"
                  (click)="navigateBasedOnStoriesAndUserId(profile.has_stories, profile.id)"
                >
                  <img [src]="profile.image ? getImageUrl(profile.image) : 'assets/images/no-image.png'" alt="" />
                </div>

                <input type="text" class="input" placeholder="Add a comment" name="comment" ngModel required />
                <button type="submit" class="button primary" [disabled]="f.invalid || !getSubmitButton()">
                  Submit
                </button>
              </div>
            </div>
          </form>
          <!-- Comments -->
        </div>
      </div>
    </div>

    <div class="right">
      <div class="profile" *ngIf="profile$ | async as profile">
        <div
          class="profile-thumbnail"
          [ngClass]="withStory(profile.has_stories.length > 0) ? 'with-story' : ''"
          (click)="profile.has_stories.length > 0 ? openStoryModal(profile) : ''"
          (click)="navigateBasedOnStoriesAndUserId(profile.has_stories, profile.id)"
        >
          <img [src]="profile.image ? getImageUrl(profile.image) : 'assets/images/no-image.png'" alt="" />
        </div>

        <div class="profile-info" (click)="navigateBasedOnUserId(profile.id)">
          <div class="profile-name">{{ profile.fname }} {{ profile.lname }}</div>
          <div class="profile-email">{{ profile.email }}</div>
        </div>
      </div>
      <div class="suggestion card" *ngIf="(suggestedUsers$ | async)?.length > 0; else noSuggestions">
        <div class="header">Suggestions</div>
        <div class="body">
          <div *ngFor="let user of suggestedUsers$ | async">
            <div class="suggested-user">
              <div
                class="suggested-user-thumbnail"
                [ngClass]="withStory(user.has_stories.length > 0) ? 'with-story' : ''"
                (click)="user.has_stories.length > 0 ? openStoryModal(user) : ''"
                (click)="navigateBasedOnStoriesAndUserId(user.has_stories, user.id)"
              >
                <img [src]="user.image ? getImageUrl(user.image) : 'assets/images/no-image.png'" alt="" />
              </div>

              <div class="suggested-user-info" (click)="navigateBasedOnUserId(user.id)">
                <div class="suggested-user-name">{{ user.fname }} {{ user.lname }}</div>
                <div class="suggested-user-email">{{ user.email }}</div>
              </div>
              <div class="button primary" (click)="onFollow(user)">Follow</div>
            </div>
          </div>
        </div>
      </div>
      <ng-template #noSuggestions>
        <div class="suggestion card text-center">
          <div class="body">No Suggestions Available</div>
        </div>
      </ng-template>
    </div>
  </div>
</div>
